using System;
using System.Data;
//using System.Windows.Forms;
using bizFacade;
//using SystemFramework;
using MesServerWork;

namespace MesServerFunctions
{
    partial class FunctionMES
    {
        /// <summary>
        ///1.扫描配送单号，用于接收物料，扫描单号的时候，将接收的物料信息显示在“物料拉动”Tab区域
        ///2.扫描料箱标签/看板卡，用于追溯物料批次信息
        ///3.扫描零件条码，根据零件图号进行防错
        ///第一步，判断条码类型，根据条码类型，执行对应的存储过程
        ///第二步，条码类型(将扫描的条码保存到对应的表中)
        ///第三步，扫描完成之后给出允许工作信号
        /// 处理页面扫描条码
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="barcode"></param>
        public void Barcode(object e)
        {

            {
                try
                {
                    DoWhatPlc.CustomeEvetnArgs msgEvent = (DoWhatPlc.CustomeEvetnArgs)e;
                    string OpName = Convert.ToString(msgEvent.OpName);
                    string barcode = Convert.ToString(msgEvent.TagValue);
                    SendMessageFun.SendInfomation("BarCodeData", barcode, OpName);  // 将扫码值发送给前端
                    string AlarmStr = "";

                    int EngineTypeID;//机型代码
                    string EngineType;//机型
                    string EngineID;//工件编号
                    string OrderForm;
                    bool isShowBarNGTipBox;

                    int IsAllowWork;
                    bool IsSuccess = false;

                    // 判断是否存在异常导致不允许工作 输出msg到前端
                    DataTable OpNameIsWorkDt = BaseDataSystemMES.OpNameIsAllowWork(OpName);
                    if (Convert.ToInt32(OpNameIsWorkDt.Rows[0]["提示类型"]) == 3)
                    {
                        SendMessageFun.SendInfomation("ShowTipBox", OpNameIsWorkDt.Rows[0]["提示文本"].ToString(), OpName);
                        return;
                    }

                    bool EngineGetOver_PLC_NextWorkStep;
                    //传递机型是否到位
                    MIS_BASE.Read_EngineGetOver_PLC(OpName, out EngineGetOver_PLC_NextWorkStep);
                    if (!EngineGetOver_PLC_NextWorkStep)
                    {
                        SendMessageFun.AsyncSendMessage_Notice(OpName, "PLC未传递机型");
                        return;
                    }
                    //物料验证
                    //BaseDataSystemMES.PartMaterial_DM_Update(OpName, barcode, out IsSuccess);
                    //if (!IsSuccess)
                    //{
                    //    SendMessageFun.AsyncSendMessage_Notice(OpName, "条码无效,请确认");
                    //    return;
                    //}
                    //else
                    //{
                    //    SendMessageFun.SendInfomation("MaterialList", "1", OpName);//通知界面更新零件信息
                    //}




                    if (barcode.Split(';').Length > 2 || barcode.Split('；').Length > 2)
                    {
                        BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.WorkStartIn, DateTime.Now.ToString());

                        DataTable dt;
                        dt = BaseDataSystemMES.GetNowWorkOrderData(OpName, 0);
                        if (dt.Rows.Count > 0)
                        {
                            if (Convert.ToInt32(dt.Rows[0]["线首是否完成工作"]) == 4)
                            {
                                MIS_BASE.WritePLC(32, OpName, true);
                                SendMessage.AsyncSendMessage_Notice(OpName, "该订单所有总成号已在MA110工作完毕，不允许继续工作，请联系班长进行修改完工状态！");
                                return;
                            }
                            else
                            {
                                EngineTypeID = Convert.ToInt32(dt.Rows[0]["机型代码"]);
                                EngineType = dt.Rows[0]["零件号"].ToString();
                                EngineID = dt.Rows[0]["变速箱总成号"].ToString();
                                OrderForm = dt.Rows[0]["订单号"].ToString();
                                MIS_BASE.WritePLC(32, OpName, false);
                            }
                        }
                        else
                        {
                            MIS_BASE.WritePLC(32, OpName, true);
                            SendMessage.AsyncSendMessage_Notice(OpName, "该订单已生产完毕或无选中的生产订单，请选择其他订单进行生产！");
                            return;
                        }
                        // 将扫码结果计入总分线记录表中
                        BaseDataSystemMES.BusPartLine_Add(EngineID, barcode, OpName, OrderForm, EngineType);
                        SendMessageFun.SendInfomation("BindRecordRefresh", "1", OpName);


                        MIS_BASE.Write_EngineID_MES(OpName, barcode);  // 将壳体码作为总成号来工作，到时候保存也存这个
                        MIS_BASE.Write_OrderForm_MES(OpName, OrderForm);
                        BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.EngineID_MES, EngineID);
                        BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.EngineType_MES, EngineType);
                        //SendMessageFun.SendMessage("1235", "1111", OpName);
                        MIS_BASE.Write_EngineTypeGetOver_MES(OpName, true);
                        //MIS_BASE.Write_FixAllow(OpName, true);
                        SendMessageFun.AsyncSendMessage_Notice(OpName, "扫码完成！");
                        BaseDataSystemMES.Check_BarCodeNGTemp(OpName, 2);
                    }
                    else
                    {
                        SendMessageFun.AsyncSendMessage_Notice(OpName, "此条码非前壳码，请确认！");
                        isShowBarNGTipBox = BaseDataSystemMES.Check_BarCodeNGTemp(OpName, 1);
                        if (isShowBarNGTipBox) SendMessageFun.SendInfomation("ShowTipBox", "多次扫描条码失败，请检查扫码位置是否正确！", OpName);
                    }


                    //获取是否允许工作
                    BaseDataSystemMES.MesServer_Judge_IsCanWork(OpName, out IsAllowWork);

                    //此处逻辑有问题   需要考虑到批次扫描  提示PLC未传递机型的情况
                    if (IsAllowWork == 1)
                    {
                        //BaseDataSystemMES.Material_Insert(OpName, 1);

                        //更新订单完工数量及物料
                        SendMessageFun.SendMessage("24", "11", OpName);

                        //工作完成
                        //MIS_BASE.Write_MaterialVerifyOver(OpName, true);
                        //if (!BaseDataSystemMES.QualityVerifyStatusOutline(OpName, out AlarmStr))
                        //{
                        //    SendInfomation("LineoutAlert", AlarmStr, OpName);
                        //    return;
                        //}
                        //通知PLC允许工作,允许工作在保存完成时清空
                        MIS_BASE.Write_FixAllow(OpName, true);
                    }
                    else
                    {
                        SendMessageFun.AsyncSendMessage_Notice(OpName, "请扫描物料！");
                    }


                }
                catch (Exception err)
                {
                    // 保存出错日志 1.申请上线 2.传递机型 3.允许保存 4.扫码
                    MisDataSaveDate.FuntionMesRead.Alarm_SaveFileLog4Error(4, e, "Fun1060", err);
                    ////ApplicationLog.WriteLog(err, "Function02:Barcode");
                }

            }

        }


    }
}
